﻿using C1.C1Preview;
using C1.WPF.Pdf;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PdfDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();            
        }
        private RenderObject GetPDFImage()
        {
            RenderTable headerTable = new RenderTable(1, 3);
            int rowIndex = 0;
            RenderImage Leftlogo = new RenderImage();
            Leftlogo.Image = new Bitmap(System.Drawing.Image.FromFile("../../logo.png"), 100, 50);
            headerTable.Width = Unit.Auto;
            headerTable.Cols[0].Width = "33.3%";
            headerTable.Cols[1].Width = "33.3%";
            headerTable.Cols[2].Width = "33.3%";
            headerTable.Rows[rowIndex].Height = new Unit(350, UnitTypeEnum.Pixel);
            headerTable.Cells[rowIndex, 0].RenderObject = Leftlogo;
            headerTable.Cells[rowIndex, 0].Style.ImageAlign.AlignHorz = ImageAlignHorzEnum.Left;
            headerTable.Cells[rowIndex, 0].Style.ImageAlign.AlignVert = ImageAlignVertEnum.Center;

            rowIndex = rowIndex + 1;
            //Seperator
            headerTable.Cells[rowIndex, 0].Text = " ";
            headerTable.Cells[rowIndex, 0].SpanCols = 3;
            headerTable.Rows[rowIndex].Height = new Unit(5, UnitTypeEnum.Mm);
            rowIndex = rowIndex + 1;
            return headerTable;
        }

        private RenderObject GetPDFGraphics()
        {          


            RenderTable headerTable = new RenderTable(1, 3);
            int rowIndex = 0;
            //added code for graphics
            int width = 100;
            int height = 50;
            var destRect = new System.Drawing.Rectangle(0, 0, width, height);
            var destImage = new Bitmap(System.Drawing.Image.FromFile("../../logo.png"), width, height);
            var image = destImage;
            RenderGraphics renderGraphics = new RenderGraphics();
            destImage.SetResolution(image.HorizontalResolution, image.VerticalResolution);

            renderGraphics.Graphics.SmoothingMode = SmoothingMode.HighQuality;
            renderGraphics.Graphics.CompositingMode = CompositingMode.SourceCopy;
            renderGraphics.Graphics.InterpolationMode =
            InterpolationMode.HighQualityBicubic;
            renderGraphics.Graphics.PixelOffsetMode = PixelOffsetMode.HighQuality;
            renderGraphics.Graphics.CompositingQuality = CompositingQuality.HighQuality;
            using (ImageAttributes wrapMode = new ImageAttributes())
            {
                wrapMode.SetWrapMode(WrapMode.TileFlipXY);
                renderGraphics.Graphics.DrawImage(image, new System.Drawing.Rectangle(0, 0, width, height), 0, 0, image.Width, image.Height, GraphicsUnit.Pixel, wrapMode);
            }

            renderGraphics.Style.ImageAlign.AlignVert = ImageAlignVertEnum.Center;


            headerTable.Width = Unit.Auto;
            headerTable.Cols[0].Width = "33.3%";
            headerTable.Cols[1].Width = "33.3%";
            headerTable.Cols[2].Width = "33.3%";
            headerTable.Rows[rowIndex].Height = new Unit(350, UnitTypeEnum.Pixel);
            headerTable.Cells[rowIndex, 0].RenderObject = renderGraphics;
            headerTable.Cells[rowIndex, 0].Style.ImageAlign.AlignHorz = ImageAlignHorzEnum.Left;
            headerTable.Cells[rowIndex, 0].Style.ImageAlign.AlignVert = ImageAlignVertEnum.Center;

            rowIndex = rowIndex + 1;
            //Seperator
            headerTable.Cells[rowIndex, 0].Text = " ";
            headerTable.Cells[rowIndex, 0].SpanCols = 3;
            headerTable.Rows[rowIndex].Height = new Unit(5, UnitTypeEnum.Mm);
            rowIndex = rowIndex + 1;
            return headerTable;
        }

        private void Create_Pdf_Graphics(object sender, RoutedEventArgs e)
        {
            C1PrintDocument doc = new C1PrintDocument();
            doc.Body.Children.Add(GetPDFGraphics());
            doc.Export(@"D:/NewFile.pdf");
            Process.Start(@"D:/NewFile.Pdf");
        }
       
        private void Create_Pdf_Image(object sender, RoutedEventArgs e)
        {
            C1PrintDocument doc = new C1PrintDocument();
            doc.Body.Children.Add(GetPDFImage());
            doc.Export(@"D:/NewFile.pdf");
            Process.Start(@"D:/NewFile.Pdf");
        }
    }
}
